; 5.5
; 炢񂵊֐
(defun tarai (x y z)
  (if (<= x y)
      y
      (tarai (tarai (- x 1) y z) (tarai (- y 1) z x) (tarai (- z 1) x y)) ))

; x]̂炢񂵊֐
(defun dtarai (x y z)
  (let ((x (if (numberp x) x (funcall x)))
       (y (if (numberp y) y (funcall y))) )
     (if (<= x y)
         y
         (let ((z (if (numberp z) z (funcall z))))
           (dtarai (lambda () (dtarai (- x 1) y z))
                   (lambda () (dtarai (- y 1) z x))
                   (lambda () (dtarai (- z 1) x y)) )))))

; x]̂炢񂵊֐i`[gŁj
(defun dtarai (x y z)
  (let ((x (if (numberp x) x (funcall x)))
       (y (if (numberp y) y (funcall y))) )
     (if (<= x y)
         y
         (dtarai (lambda () (dtarai (- x 1) y z))
                 (lambda () (dtarai (- y 1) z x))
                 (lambda () (dtarai (- z 1) x y)) ))))

; }bJ[V[ł炢񂵊֐
(defun tak (x y z)
  (if (<= x y)
      z
      (tak (tak (- x 1) y z) (tak (- y 1) z x) (tak (- z 1) x y)) ))

; Xgł炢񂵊֐
(defun ltarai (x y z)
  (if (<= (length x) (length y))
    y
    (ltarai (ltarai (cdrnil x) y z)
          (ltarai (cdrnil y) z x)
          (ltarai (cdrnil z) x y) )))

; N[Wƃ}Nɂ閳Xg
(defmacro delay-cons (x y)
   `(cons ,x (lambda () ,y)) )
(defun delay-car (x) (car x))
(defun delay-cdr (x) 
   (let ((ret (funcall (cdr x))))
      (setf (cdr x) ret) ))
(defun infinite-n (n)
  (delay-cons n (infinite-n (+ n 1))) )

; NH[gƃ}Nɂ閳Xg
; delay-cons
(defmacro delay-cons2 (x y)
   `(cons ,x ',y) )
; delay-car
(defun delay-car2 (x) (car x))
; delay-cdr
(defun delay-cdr2 (x) 
   (let ((ret (eval (cdr x))))
      (setf (cdr x) ret) ))
; infinite-n
(defmacro infinite-n2 (n)
  `(delay-cons2 ,n (infinite-n2 ,(+ n 1))) )

;;; test
(defun test (tests)
  (dolist (test tests)
    (print test)
    (princ "---->")
    (terpri)
    (print (eval test)) 
    (terpri) ))

(defmacro dolist (lists &rest forms) 
   `(let ((list ,(second lists))
          (,(car lists) nil) )
       (while list 
              (setq ,(car lists) (car list))
              ,@forms 
              (setq list (cdr list)) )))

(defun print (arg &rest opt) 
  (let ((stream (standard-output))) 
     (if opt (setq stream (car opt)))
     (format stream "~S~%" arg) ))

(defun princ (arg &rest opt) 
  (let ((stream (standard-output))) 
     (if opt (setq stream (car opt)))
     (format stream arg) ))

(defun terpri (&rest opt) 
  (let ((stream (standard-output))) 
     (if opt (setq stream (car opt)))
     (format stream "~%") ))

(defun second (x) (car (cdr x)))

(defun cdrnil (x) (if (null x) nil (cdr x)))

(defglobal tests '(

(tarai 3 2 1)
(dtarai 3 2 1)
(tak 3 2 1)
(ltarai '(0 1 2 3 4 5 6 7 8 9) '(0 1 2 3 4) ())

(defglobal list0 (infinite-n 1))
(delay-car list0)
(defglobal list1 (delay-cdr list0))
(defglobal list2 (delay-cdr list1))
(defglobal list3 (delay-cdr list2))
list0

(defglobal list0-2 (infinite-n2 1))
(delay-car2 list0-2)
(defglobal list1-2 (delay-cdr2 list0-2))
(defglobal list2-2 (delay-cdr2 list1-2))
(defglobal list3-2 (delay-cdr2 list2-2))
list0-2

))

(test tests)

